/**************************************************
 * soubor sbln-zsbstr.cpp
 * zsobnk jako ablonov tda a jej instance
 **************************************************/
#include <iostream>
#include <new>
#include <string>
#include <exception>
#include <stdexcept>
using namespace std;

template <class sablona> class zasobnik {
private:
	int velikost;
	sablona *vrchol, *pzasobnik;
public:
	zasobnik(int i = 100) : velikost(i) {
		vrchol = pzasobnik = new sablona[velikost];
	}
	~zasobnik() {
		delete[] pzasobnik;
	}
	void push(sablona i) {
		if ((vrchol-pzasobnik) < velikost) {
			*vrchol = i; vrchol++;
		}
	}
	sablona pop() {
		if (--vrchol >= pzasobnik)
			return *vrchol;
		else
			throw new 
				out_of_range("neni prostor na zasobniku");
	}
}; // class zasobnik

int main() {
    int i;
	zasobnik <double> zas2; 
	for (i = 0; i < 50; i++)
		zas2.push(i + i / 1000.0);
	cout << "zasobnik <double>:" << endl;
	for(i = 0; i < 5; i++)
		cout << zas2.pop() << '\t';

	cout << endl << "ted zadej par radku textu, "
		"ukonci 2x prazdnym radkem:" << endl;
	zasobnik <string> zas3;
	string s = " ";
	int kolik = 0;
	while (s.length() != 0) {
		getline(cin, s, '\n');
		zas3.push(*(new string(s)));
		kolik++;
	} // while (s.length() != 0)
	cout << "zasobnik <string>:" << endl;
    while (kolik--) {
		cout << zas3.pop() << endl;
	} // while (kolik--)
	return 0;
} // int main()