/********************************************
 * soubor strif-bn.cpp
 * vyaduje binrn soubor (double) odmoc.dta
 * s hodnotami druhch odmocnin sel 1-100
 * ukazuje nhodn pstup pomoc seekg()
 ********************************************/

#include <iostream>
#include <fstream>
#include <iomanip>

using namespace std;

const char *jmeno = "odmoc.dta";

int main() {
 ifstream ifs(jmeno, ios::in | ios::binary);
 if (ifs != 0) {
   double f;
   int i;
   cout<< setw(7) << setprecision(4)
	   << setiosflags(ios::showpoint | ios::showpos); 
   cout << "Zadej cele cislo v rozsahu <1, 100>:";
   cin >> i;
   while ((i > 0) && (i < 101)) {
	ifs.seekg((i - 1) * sizeof(f), ios::beg);
	ifs.read((char *) &f, sizeof(f));
	cout << "druha odmocnina z " << i << "\tje " << f;
	cout << endl 
         << "Zadej cele cislo v rozsahu <1, 100>:";
	cin >> i;
   } // while()
  cout << endl << "Konec." << endl;
  ifs.close();
 } // if (ifs != 0)
 return 0;
} // int main()