/********************************
 * soubor cpp-show.cpp/c
 * monosti preprocesoru
 * a nkter rozdly mezi C a C++
 ********************************/

#ifndef __cplusplus
 #include <stdio.h>
 #include <math.h>
 /* #define M_PI 3.1415926535897932384626433832795L */
#else
 #include <iostream>	// vstupy a vstupy
 #include <iomanip> // formtovn vstupu
 #include <string>
 #include <math.h>
 using namespace std; 
// const double M_PI = 3.1415926535897932384626433832795L;
#endif

#ifndef __cplusplus
 #define STR "zrejme odpovida standardu C"
 #define N 5
#else
 const string STR = "odpovida standardu C++";
 const int N = 5;
#endif

int main(void)
{
 int i, vektor[N];

 for (i = 0; i < N; i++)
   vektor[i] = i * i;

#ifndef __cplusplus
 puts(STR);
#else
 cout << STR << endl;
#endif

 for (i = 0; i < N; i++)
#ifndef __cplusplus
  printf("%3d\t%5d\n", i, vektor[i]);
#else
  cout << setw(3) << '\t' << i 
	   << setw(5) << vektor[i] << endl;
#endif

#ifndef __cplusplus
 printf("pi = %10.8f\n", M_PI);

 #define M_PI 6.
 printf("pi = %10.8f\n", M_PI);
#else
 cout << setprecision(8) << M_PI << endl;
 // M_PI = 6.;
 // cout << M_PI << endl;
#endif

 return 0;
} // int main(void)